Index: /branches/2012/dev_MERGE_2012/NEMOGCM/CONFIG/PELAGOS_OFF/EXP00/namelist_top
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/CONFIG/PELAGOS_OFF/EXP00/namelist_top	(revision 3680)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/CONFIG/PELAGOS_OFF/EXP00/namelist_top	(revision 3680)
@@ -0,0 +1,143 @@
+!!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+!! NEMO/TOP1 :  1 - tracer definition                     (namtrc    )
+!!              2 - tracer data initialisation            (namtrc_dta)
+!!              3 - tracer advection                      (namtrc_adv)
+!!              4 - tracer lateral diffusion              (namtrc_ldf)
+!!              5 - tracer vertical physics               (namtrc_zdf)
+!!              6 - tracer newtonian damping              (namtrc_dmp)
+!!              7 - dynamical tracer trends               (namtrc_trd)
+!!              8 - tracer output diagonstics             (namtrc_dia)
+!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+!'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
+&namtrc     !   tracers definition
+!,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
+   nn_dttrc      =  1        !  time step frequency for passive sn_tracers      
+   ln_top_euler  = .true.    !  Euler timestepping
+!
+!                !    name   ! title of the field   ! initial data ! initial data ! save   !
+!                !           !                                           !  units       ! from file    ! or not ! 
+!                !           !                                           !              ! or not       !        !
+   sn_tracer(1)   = 'DUMMY'  , 'Dummy tracer'                      ,       'dummy units',  .false.     ,  .true.
+/
+!-----------------------------------------------------------------------
+&namtrc_dta      !    Initialisation from data input file
+!-----------------------------------------------------------------------
+!
+!                !  file name               ! frequency (hours) ! variable   ! time interp. !  clim  ! 'yearly'/ ! weights  ! rotation !
+!                !                          !  (if <0  months)  !   name     !   (logical)  !  (T/F) ! 'monthly' ! filename ! pairing  !
+   sn_trcdta(1)  = 'data_1m_O2_nomask'      ,        -1         ,  'O2'      ,    .false.   , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(2)  = 'data_1m_PO4_nomask'     ,        -1         ,  'PO4'     ,    .false.   , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(3)  = 'data_1m_NO3_nomask'     ,        -1         ,  'NO3'     ,    .false.   , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(6)  = 'data_1m_Si_nomask'      ,        -1         ,  'Si'      ,    .false.   , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(8)  = 'data_1m_Fer_nomask'     ,        -12        ,  'Fer'     ,    .false.   , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(45) = 'data_1m_DOC_nomask'     ,        -12        ,  'DOC'     ,    .false.   , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(56) = 'data_1m_DIC_nomask'     ,        -12        ,  'DIC'     ,    .false.   , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(57) = 'data_1m_Alkalini_nomask',        -12        ,  'Alkalini',    .false.   , .true. , 'yearly'  , ''       , ''
+!
+   cn_dir        =  './'      !  root directory for the location of the data files
+   rn_trfac(1)   =   22.4  !  conversion factor from ml/l to mmol m3 (1 mol O2 = 22.4 l) 
+   rn_trfac(2)   =   1.0   !  -      -      -     -
+   rn_trfac(3)   =   1.0   !  -      -      -     -
+   rn_trfac(6)   =   1.0   !  -      -      -     -
+   rn_trfac(8)   =   1.e9  !  conversion factor from mol/l to umol/m3
+   rn_trfac(45)  =  12.e6  !  conversion factor from mol/l to mg/m3
+   rn_trfac(56)  =  12.0   !  conversion factor from umol/l to mg/m3
+   rn_trfac(57)  =   1.0   !  -      -      -     -
+/
+!-----------------------------------------------------------------------
+&namtrc_bc
+!-----------------------------------------------------------------------
+!              ! file name                ! frequency (hr) ! variable ! time interp. ! clim    !'yearly' or ! weights  ! rotation
+!              !                          !  (if <0 mon)   !   name   !  (logical)   ! (T/F)   ! 'monthly'  ! filename ! pairing
+   sn_trcsbc(3)  = 'ndeposition.orca'     ,        -1      ,  'ndep'      ,  .false.  , .true.  , 'yearly'   , ''       , ''
+   sn_trcsbc(8)  = 'dust.orca'            ,        -1      ,  'dust'      ,  .false.  , .true.  , 'yearly'   , ''       , ''
+
+   rn_trsfac(3)  = 1.0
+   rn_trsfac(8)  = 5.8866e+05             ! conversion factor from kg Fe/m2/mon to umol/m2/d = 1.e9/(55.85)*12/365
+   !
+   sn_trccbc(2)  = 'river'                 ,       -12      ,  'RIVERPHOS'  ,  .false.  , .true.  , 'yearly'   , ''       , ''
+   sn_trccbc(3)  = 'river'                 ,       -12      ,  'RIVERNIT'   ,  .false.  , .true.  , 'yearly'   , ''       , ''
+   sn_trccbc(6)  = 'river'                 ,       -12      ,  'RIVERSIL'   ,  .false.  , .true.  , 'yearly'   , ''       , ''
+   sn_trccbc(8)  = 'river'                 ,       -12      ,  'RIVERFe80'  ,  .false.  , .true.  , 'yearly'   , ''       , ''
+   sn_trccbc(45) = 'river'                 ,       -12      ,  'RIVERDOC'   ,  .false.  , .true.  , 'yearly'   , ''       , ''
+   sn_trccbc(56) = 'river'                 ,       -12      ,  'RIVERDIC'   ,  .false.  , .true.  , 'yearly'   , ''       , ''
+   rn_trcfac(2)  =  8.8464e+10     ! 1 mol P = 30.97 g; 1.e12*1.e3/30.97/365 conversion factor from Tg/y to mmol/d
+   rn_trcfac(3)  =  1.9556e+11     ! 1 mol N = 14.01 g; 1.e12*1.e3/14.01/365 conversion factor from Tg/y to mmol/d
+   rn_trcfac(6)  =  9.7534e+10     ! 1 mol Si = 28.09 g; 1.e12*1.e3/28.09/365 conversion factor from Tg/y to mmol/d
+   rn_trcfac(8)  =  4.9055e+13     ! 1 mol Fe = 55.85 g; 1.e12*1.e6/55.85/365 conversion factor from Tg/y to umol/d
+   rn_trcfac(45) =  2.7397e+12     ! 1.e15/365 ! conversion factor from Tg/y to mg/d
+   rn_trcfac(56) =  2.7397e+12     ! 1.e15/365 ! conversion factor from Tg/y to mg/d
+   cn_dir       = './'     !  root directory for the location of the boundary condition files
+/
+!-----------------------------------------------------------------------
+&namtrc_adv    !   advection scheme for passive tracer 
+!-----------------------------------------------------------------------
+   ln_trcadv_cen2   =  .false.  !  2nd order centered scheme   
+   ln_trcadv_tvd    =  .false.  !  TVD scheme
+   ln_trcadv_muscl  =  .true.   !  MUSCL scheme
+   ln_trcadv_muscl2 =  .false.  !  MUSCL2 scheme + cen2 at boundaries
+   ln_trcadv_ubs    =  .false.  !  UBS scheme
+   ln_trcadv_qck    =  .false.  !  QUICKEST scheme
+/
+!-----------------------------------------------------------------------
+&namtrc_ldf    !   lateral diffusion scheme for passive tracer 
+!-----------------------------------------------------------------------
+   ln_trcldf_diff   =  .true.   !  performs lateral diffusion (T) or not (F)
+!                               !  Type of the operator : 
+   ln_trcldf_lap    =  .true.   !     laplacian operator       
+   ln_trcldf_bilap  =  .false.  !     bilaplacian operator     
+                                !  Direction of action  :
+   ln_trcldf_level  =  .false.  !     iso-level                
+   ln_trcldf_hor    =  .false.  !     horizontal (geopotential)         (require "key_ldfslp" when ln_sco=T)
+   ln_trcldf_iso    =  .true.   !     iso-neutral                       (require "key_ldfslp")
+!                               !  Coefficient
+   rn_ahtrc_0       =  2000.    !  horizontal eddy diffusivity for tracers [m2/s]
+   rn_ahtrb_0       =     0.    !     background eddy diffusivity for ldf_iso [m2/s]
+/
+!-----------------------------------------------------------------------
+&namtrc_zdf        !   vertical physics
+!-----------------------------------------------------------------------
+   ln_trczdf_exp   =  .false.  !  split explicit (T) or implicit (F) time stepping
+   nn_trczdf_exp   =   3       !  number of sub-timestep for ln_trczdfexp=T
+/
+!-----------------------------------------------------------------------
+&namtrc_rad        !  treatment of negative concentrations 
+!-----------------------------------------------------------------------
+   ln_trcrad   =  .true.  !  artificially correct negative concentrations (T) or not (F)
+/
+!-----------------------------------------------------------------------
+&namtrc_dmp    !   passive tracer newtonian damping   
+!-----------------------------------------------------------------------
+   ln_trcdmp   =  .false.  !  add a damping term (T) or not (F)
+   nn_hdmp_tr  =   -1      !  horizontal shape =-1, damping in Med and Red Seas only
+                           !                   =XX, damping poleward of XX degrees (XX>0)
+                           !                      + F(distance-to-coast) + Red and Med Seas
+   nn_zdmp_tr  =    1      !  vertical   shape =0    damping throughout the water column
+                           !                   =1 no damping in the mixing layer (kz  criteria)
+                           !                   =2 no damping in the mixed  layer (rho crieria)
+   rn_surf_tr  =   50.     !  surface time scale of damping   [days]
+   rn_bot_tr   =  360.     !  bottom  time scale of damping   [days]
+   rn_dep_tr   =  800.     !  depth of transition between rn_surf and rn_bot [meters]
+   nn_file_tr  =    0      !  create a damping.coeff NetCDF file (=1) or not (=0)
+/
+!-----------------------------------------------------------------------
+&namtrc_trd       !   diagnostics on tracer trends        ('key_trdtrc')
+!                          or mixed-layer trends          ('key_trdmld_trc')
+!----------------------------------------------------------------------
+   nn_trd_trc  =  360       !  time step frequency and tracers trends
+   nn_ctls_trc =   0        !  control surface type in mixed-layer trends (0,1 or n<jpk)
+   rn_ucf_trc  =   86400    !  unit conversion factor (=1 -> /seconds ; =86400. -> /day)
+   ln_trdmld_trc_restart = .false.  !  restart for ML diagnostics
+   ln_trdmld_trc_instant = .false.  !  flag to diagnose trends of instantantaneous or mean ML T/S
+   ln_trdtrc(1)  =   .true.
+   ln_trdtrc(2)  =   .true.
+   ln_trdtrc(23) =   .true.
+/
+!-----------------------------------------------------------------------
+&namtrc_dia       !   parameters for passive tracer additional diagnostics
+!----------------------------------------------------------------------
+   ln_diatrc     =  .false.   !  save additional diag. (T) or not (F)
+   ln_diabio     =  .false.
+   nn_writedia   =  5475     !  time step frequency for diagnostics
+   nn_writebio   =  5475
+/
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/CONFIG/PELAGOS_OFF/EXP00/runscript
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/CONFIG/PELAGOS_OFF/EXP00/runscript	(revision 3680)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/CONFIG/PELAGOS_OFF/EXP00/runscript	(revision 3680)
@@ -0,0 +1,40 @@
+#! /bin/sh -x
+
+#BSUB -a poe
+#BSUB -J PEL_OFF          # Name of the job.
+#BSUB -o PELAGOS_%J.out  # Appends std output to file %J.out.
+#BSUB -e PELAGOS_%J.err  # Appends std error to file %J.out.
+#BSUB -P nemo
+#BSUB -q poe_short    # queue
+#BSUB -n 128          # Number of CPUs
+#BSUB -x 
+#BSUB -R "span[ptile=64]"
+
+export MP_WAIT_MODE=poll
+export MP_POLLING_INTERVAL=30000000
+export MP_SHARED_MEMORY=yes
+export MP_EUILIB=us
+export MP_EUIDEVICE=sn_all
+export LDR_CNTRL=TEXTPSIZE=64K@STACKPSIZE=64K@DATAPSIZE=64K
+export MP_TASK_AFFINITY=core
+
+EXP="EXP00_OFF"
+
+workdir="/data/ans017/EXPERIMENTS/PELAGOS/${EXP}"
+datadir="/users/home/ans017/WORKS/GIT/ORCA2-DATA"
+execdir=`pwd`
+
+if [ ! -d ${workdir} ] ; then
+  mkdir -p ${workdir}
+fi
+
+cd ${workdir}
+rm -rf *
+# Copy input files to exp folder
+cp ${execdir}/* ./
+ln -sf ${datadir}/* ./
+ln -sf ${datadir}/ORCA2-TOP/* ./
+# Get the offline physical data and the mesh_mask
+ln -sf /data/ans017/EXPERIMENTS/ORCA2_LIM/*.nc ./
+
+time mpirun.lsf opa
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/CONFIG/PELAGOS_OFF/EXP00/xmlio_server.def
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/CONFIG/PELAGOS_OFF/EXP00/xmlio_server.def	(revision 3680)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/CONFIG/PELAGOS_OFF/EXP00/xmlio_server.def	(revision 3680)
@@ -0,0 +1,35 @@
+! xmlio_server namelist
+!
+! using_server: .TRUE.(.FALSE.) to use(bypass) the io_server
+! using_oasis : .TRUE.(.FALSE.) if nemo is coupled through OASIS
+! client_id   : used only for OASIS, NEMO      id in the namecouple 
+! server_id   : used only for OASIS, io_server id in the namecouple
+!
+&coupling_param
+  using_server = .FALSE.
+  using_oasis  = .FALSE.
+  client_id    = 'nemo.x'
+  server_id    = 'ionemo'
+/
+
+! global_mpi_buffer_size: size in Mo of the MPI buffer used by the io_server
+&mpi_param
+  global_mpi_buffer_size = 512
+/  
+
+!!======================================================================
+!!   namnc4            netcdf4 chunking and compression settings
+!!======================================================================
+!-----------------------------------------------------------------------
+&namnc4         !  netcdf4 chunking and compression settings
+                !  (benign if "key_netcdf4" is not used)
+!-----------------------------------------------------------------------
+   nn_nchunks_i   =   4       !  number of chunks in i-dimension
+   nn_nchunks_j   =   4       !  number of chunks in j-dimension
+   nn_nchunks_k   =   31      !  number of chunks in k-dimension
+                              !  setting nn_nchunks_k = jpk will give a chunk size of 1 in the vertical which
+                              !  is optimal for postprocessing which works exclusively with horizontal slabs
+   ln_nc4zip      =   .TRUE.  !  (T) use netcdf4 chunking and compression
+                              !  (F) ignore chunking information and produce netcdf3-compatible files  
+/
+  
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/CONFIG/PELAGOS_OFF/cpp_PELAGOS_OFF.fcm
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/CONFIG/PELAGOS_OFF/cpp_PELAGOS_OFF.fcm	(revision 3680)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/CONFIG/PELAGOS_OFF/cpp_PELAGOS_OFF.fcm	(revision 3680)
@@ -0,0 +1,2 @@
+bld::tool::fppkeys key_trabbl key_orca_r2 key_ldfslp key_traldf_c2d key_traldf_eiv key_top key_offline key_my_trc key_iomput key_mpp_mpi
+inc $BFMDIR/src/nemo/bfm.fcm
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/CONFIG/makenemo
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/CONFIG/makenemo	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/CONFIG/makenemo	(revision 3680)
@@ -302,6 +302,12 @@
 #if AGRIF we do a first preprocessing
     if [ ${#x_c} -eq 0 ]; then
-        [ "$AGRIFUSE" == 1 ] && fcm build --ignore-lock -s 2 ${COMPIL_DIR}/$USEBLD
-        [ "$AGRIFUSE" == 1 ] && rm -rf  ${NEMO_TDIR}/${NEW_CONF}/BLD/*
+       if [ "$AGRIFUSE" == 1 ]; then 
+          fcm build --ignore-lock  -j 1 ${COMPIL_DIR}/bld_preproagr.cfg ||{ cd - ; exit ;}
+          echo ""
+          echo "---------------------------------"
+          echo "CONV preprocessing successfull !!"
+          echo "---------------------------------"
+          echo ""
+       fi
     fi
     fcm build ${x_c} --ignore-lock -v ${x_v} -j ${NBR_PRC} ${COMPIL_DIR}/$USEBLD || cd -
@@ -311,4 +317,5 @@
 #add remove for clean option
     if  [ ${#x_c} -ne 0 ]; then
+        rm -rf ${NEMO_TDIR}/${NEW_CONF}/OPAFILES
         rm -rf ${NEMO_TDIR}/${NEW_CONF}/WORK
         rm -rf ${NEMO_TDIR}/${NEW_CONF}/BLD
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/EXTERNAL/IOIPSL/tools/flio_rbld.f90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/EXTERNAL/IOIPSL/tools/flio_rbld.f90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/EXTERNAL/IOIPSL/tools/flio_rbld.f90	(revision 3680)
@@ -678,4 +678,12 @@
               io_sl(v_d_ul(iv))=it
             ENDIF
+          ENDIF
+!-------- Initialize to zero variables data 
+          ! approximate dimension
+          IF ( it == 1 .AND. l_cgd) THEN
+          ! Enter I*J I*J is larger thant total number of single files
+            if ( ((f_d_l(1)/(d_s_l(1,1)-3)) * (f_d_l(2)/(d_s_l(2,1)-3) )) .gt. d_n_t ) then 
+              CALL ZeroFill (f_id_o, f_v_nm(iv), f_d_l, v_d_nb(iv), v_type(iv), v_d_i(1:v_d_nb(iv),iv))
+            endif
           ENDIF
         ENDIF
@@ -1621,4 +1629,156 @@
 END SUBROUTINE flrb_rg
 !===
+SUBROUTINE ZeroFill(f_id_o,f_v_nm,f_d_l,v_d_nb,v_type,v_d_i)
+
+  IMPLICIT NONE
+! Character length
+  INTEGER,PARAMETER :: chlen=256
+
+  INTEGER              :: v_d_nb, v_type ! variable # of dims, variable type, var Unlim dimension
+  INTEGER              :: f_id_o         ! Output file ID
+  INTEGER,DIMENSION(:) :: f_d_l, v_d_i    ! Global dimensions, variable dimensio ID
+  CHARACTER(LEN=chlen) :: f_v_nm         ! Variable name
+  INTEGER,DIMENSION(:),ALLOCATABLE :: dims
+
+  INTEGER(KIND=i_2) :: i2_0d
+  INTEGER(KIND=i_2), ALLOCATABLE :: i2_1d(:), i2_2d(:,:), i2_3d(:,:,:), i2_4d(:,:,:,:), i2_5d(:,:,:,:,:)
+  INTEGER(KIND=i_4) :: i4_0d
+  INTEGER(KIND=i_4), ALLOCATABLE :: i4_1d(:), i4_2d(:,:), i4_3d(:,:,:), i4_4d(:,:,:,:), i4_5d(:,:,:,:,:)
+  REAL(KIND=r_4) :: r4_0d
+  REAL(KIND=r_4), ALLOCATABLE    :: r4_1d(:), r4_2d(:,:), r4_3d(:,:,:), r4_4d(:,:,:,:), r4_5d(:,:,:,:,:)
+  REAL(KIND=r_8) :: r8_0d
+  REAL(KIND=r_8), ALLOCATABLE    :: r8_1d(:), r8_2d(:,:), r8_3d(:,:,:), r8_4d(:,:,:,:), r8_5d(:,:,:,:,:)
+  
+  ! write(*,*) ' Into my sub... TOM'
+  ! write(*,*) f_id_o, TRIM(f_v_nm), v_d_nb , v_type
+  write(*,*) 'Variable: ',TRIM(f_v_nm), ' intiliazed to zero'
+  write(*,*)
+
+  ! define variable dimension
+  ALLOCATE(dims(v_d_nb)) 
+  dims=f_d_l(v_d_i)
+  SELECT CASE(v_type) 
+    ! INTEGER 1 and 2 
+    CASE (flio_i1,flio_i2)
+      SELECT CASE (v_d_nb)
+       CASE(1)
+         ALLOCATE(i2_1d(dims(1)))
+         i2_1d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),i2_1d)
+         DEALLOCATE(i2_1d)
+       CASE(2)
+         ALLOCATE(i2_2d(dims(1),dims(2)))
+         i2_2d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),i2_2d) 
+         DEALLOCATE(i2_2d)
+       CASE(3)
+         ALLOCATE(i2_3d(dims(1),dims(2),dims(3)))
+         i2_3d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),i2_3d)
+         DEALLOCATE(i2_3d)
+       CASE(4)
+         ALLOCATE(i2_4d(dims(1),dims(2),dims(3),dims(4)))
+         i2_4d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),i2_4d)
+         DEALLOCATE(i2_4d)
+       CASE(5)
+         ALLOCATE(i2_5d(dims(1),dims(2),dims(3),dims(4),dims(5)))
+         i2_5d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),i2_5d)
+         DEALLOCATE(i2_5d)
+      END SELECT
+    ! INTEGER 4
+    CASE (flio_i4)
+      SELECT CASE (v_d_nb)
+       CASE(1)
+         ALLOCATE(i4_1d(dims(1)))
+         i4_1d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),i4_1d)
+         DEALLOCATE(i4_1d)
+       CASE(2)
+         ALLOCATE(i4_2d(dims(1),dims(2)))
+         i4_2d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),i4_2d)
+         DEALLOCATE(i4_2d)
+       CASE(3)
+         ALLOCATE(i4_3d(dims(1),dims(2),dims(3)))
+         i4_3d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),i4_3d)
+         DEALLOCATE(i4_3d)
+       CASE(4)
+         ALLOCATE(i4_4d(dims(1),dims(2),dims(3),dims(4)))
+         i4_4d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),i4_4d)
+         DEALLOCATE(i4_4d)
+       CASE(5)
+         ALLOCATE(i4_5d(dims(1),dims(2),dims(3),dims(4),dims(5)))
+         i4_5d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),i4_5d)
+         DEALLOCATE(i4_5d)
+      END SELECT
+    ! FLOAT 4
+    CASE (flio_r4)
+      SELECT CASE (v_d_nb)
+       CASE(1)
+         ALLOCATE(r4_1d(dims(1)))
+         r4_1d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),r4_1d) 
+         DEALLOCATE(r4_1d)
+       CASE(2)
+         ALLOCATE(r4_2d(dims(1),dims(2)))
+         r4_2d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),r4_2d) 
+         DEALLOCATE(r4_2d)
+       CASE(3)
+         ALLOCATE(r4_3d(dims(1),dims(2),dims(3)))
+         r4_3d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),r4_3d) 
+         DEALLOCATE(r4_3d)
+       CASE(4)
+         ALLOCATE(r4_4d(dims(1),dims(2),dims(3),dims(4)))
+         r4_4d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),r4_4d)
+         DEALLOCATE(r4_4d)
+       CASE(5)
+         ALLOCATE(r4_5d(dims(1),dims(2),dims(3),dims(4),dims(5)))
+         r4_5d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),r4_5d)
+         DEALLOCATE(r4_5d)
+      END SELECT
+    ! FLOAT 8
+    CASE (flio_r8)
+      SELECT CASE (v_d_nb)
+       CASE(1)
+         ALLOCATE(r8_1d(dims(1)))
+         r8_1d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),r8_1d)
+         DEALLOCATE(r8_1d)
+       CASE(2)
+         ALLOCATE(r8_2d(dims(1),dims(2)))
+         r8_2d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),r8_2d) 
+         DEALLOCATE(r8_2d)
+       CASE(3)
+         ALLOCATE(r8_3d(dims(1),dims(2),dims(3)))
+         r8_3d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),r8_3d)
+         DEALLOCATE(r8_3d)
+       CASE(4)
+         ALLOCATE(r8_4d(dims(1),dims(2),dims(3),dims(4)))
+         r8_4d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),r8_4d)
+         DEALLOCATE(r8_4d)
+       CASE(5)
+         ALLOCATE(r8_5d(dims(1),dims(2),dims(3),dims(4),dims(5)))
+         r8_5d=0
+         CALL flioputv (f_id_o,TRIM(f_v_nm),r8_5d)
+         DEALLOCATE(r8_5d)
+      END SELECT
+  END SELECT
+
+  DEALLOCATE (dims)
+
+END SUBROUTINE
+!===
 !--------------------
 END PROGRAM flio_rbld
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/LIM_SRC_2/limrhg_2.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/LIM_SRC_2/limrhg_2.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/LIM_SRC_2/limrhg_2.F90	(revision 3680)
@@ -32,4 +32,7 @@
    USE oce     , ONLY : snwice_mass, snwice_mass_b
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
+#if defined key_agrif
+   USE agrif_lim2_interp ! nesting
+#endif
 
    IMPLICIT NONE
@@ -148,4 +151,8 @@
          zpice(:,:) = ssh_m(:,:)
       ENDIF
+#if defined key_agrif
+      ! load the boundary value of velocity in special array zuive and zvice
+      CALL agrif_rhg_lim2_load
+#endif
 
       ! Ice mass, ice strength, and wind stress at the center            |
@@ -552,4 +559,10 @@
             CALL lbc_lnk( zv_n(:,1:jpj), 'I', -1. )
 
+#if defined key_agrif
+            ! copy the boundary value from u_ice_nst and v_ice_nst to u_ice and v_ice
+            ! before next interations
+            CALL agrif_rhg_lim2(zu_n,zv_n)
+#endif
+
             ! Test of Convergence
             DO jj = k_j1+1 , k_jpj-1
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/LIM_SRC_2/limtrp_2.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/LIM_SRC_2/limtrp_2.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/LIM_SRC_2/limtrp_2.F90	(revision 3680)
@@ -28,4 +28,7 @@
    USE lib_mpp         ! MPP library
    USE wrk_nemo        ! work arrays
+# if defined key_agrif
+   USE agrif_lim2_interp ! nesting
+# endif
 
    IMPLICIT NONE
@@ -80,4 +83,8 @@
 
       IF( kt == nit000  )   CALL lim_trp_init_2      ! Initialization (first time-step only)
+
+# if defined key_agrif
+      CALL agrif_trp_lim2_load      ! First interpolation
+# endif
 
       zsm(:,:) = area(:,:)
@@ -269,4 +276,8 @@
       ENDIF
       !
+# if defined key_agrif
+      CALL agrif_trp_lim2      ! Fill boundaries of the fine grid
+# endif
+      ! 
       CALL wrk_dealloc( jpi, jpj, zui_u , zvi_v , zsm, zs0ice, zs0sn , zs0a, zs0c0 , zs0c1 , zs0c2 , zs0st )
       !
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90	(revision 3680)
@@ -8,5 +8,6 @@
    !!             -   !  2008-11  (M. Vancoppenolle, S. Bouillon, Y. Aksenov) add surface tilt in ice rheolohy 
    !!            3.3  !  2009-05  (G.Garric) addition of the lim2_evp cas
-   !!            4.0  !  2011-01  (A Porter)  dynamical allocation 
+   !!            3.4  !  2011-01  (A. Porter)  dynamical allocation 
+   !!            3.5  !  2012-08  (R. Benshila)  AGRIF 
    !!----------------------------------------------------------------------
 #if defined key_lim3 || (  defined key_lim2 && ! defined key_lim2_vp )
@@ -37,4 +38,7 @@
    USE prtctl         ! Print control
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
+#if defined key_agrif && defined key_lim2
+   USE agrif_lim2_interp
+#endif
 
    IMPLICIT NONE
@@ -168,4 +172,7 @@
      at_i(:,:) = 1. - frld(:,:)
 #endif
+#if defined key_agrif && defined key_lim2 
+    CALL agrif_rhg_lim2_load      ! First interpolation of coarse values
+#endif
       !
       !------------------------------------------------------------------------------!
@@ -510,4 +517,7 @@
 
             CALL lbc_lnk( u_ice(:,:), 'U', -1. )
+#if defined key_agrif
+            CALL agrif_rhg_lim2( jter, nevp, 'U' )
+#endif
 
 !CDIR NOVERRCHK
@@ -535,4 +545,7 @@
 
             CALL lbc_lnk( v_ice(:,:), 'V', -1. )
+#if defined key_agrif
+            CALL agrif_rhg_lim2( jter, nevp, 'V' )
+#endif
 
          ELSE 
@@ -561,4 +574,7 @@
 
             CALL lbc_lnk( v_ice(:,:), 'V', -1. )
+#if defined key_agrif
+            CALL agrif_rhg_lim2( jter, nevp , 'V' )
+#endif
 
 !CDIR NOVERRCHK
@@ -589,4 +605,7 @@
 
             CALL lbc_lnk( u_ice(:,:), 'U', -1. )
+#if defined key_agrif
+            CALL agrif_rhg_lim2( jter, nevp, 'U' )
+#endif
 
          ENDIF
@@ -629,4 +648,8 @@
       CALL lbc_lnk( u_ice(:,:), 'U', -1. ) 
       CALL lbc_lnk( v_ice(:,:), 'V', -1. ) 
+#if defined key_agrif
+      CALL agrif_rhg_lim2( nevp , nevp, 'U' )
+      CALL agrif_rhg_lim2( nevp , nevp, 'V' )
+#endif
 
       DO jj = k_j1+1, k_jpj-1 
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif2model.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif2model.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif2model.F90	(revision 3680)
@@ -5,4 +5,9 @@
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
+   SUBROUTINE Agrif2Model
+      !!---------------------------------------------
+      !!   *** ROUTINE Agrif2Model ***
+      !!--------------------------------------------- 
+   END SUBROUTINE Agrif2model
 
    SUBROUTINE Agrif_Set_numberofcells(Agrif_Gr)
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_ice.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_ice.F90	(revision 3680)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_ice.F90	(revision 3680)
@@ -0,0 +1,63 @@
+MODULE agrif_ice
+   !!======================================================================
+   !!                       ***  MODULE agrif_ice  ***
+   !! AGRIF :   define in memory AGRIF variables for sea-ice
+   !!----------------------------------------------------------------------
+   !! History :  3.4  ! 2012-08  (R. Benshila)  Original code
+   !!----------------------------------------------------------------------
+#if defined key_agrif && defined key_lim2
+   !!----------------------------------------------------------------------
+   !!   'key_agrif'                                              AGRIF zoom
+   !!----------------------------------------------------------------------
+   USE par_oce      ! ocean parameters
+   
+   IMPLICIT NONE
+   PRIVATE 
+
+   PUBLIC agrif_ice_alloc ! routine called by nemo_init in nemogcm.F90
+
+   INTEGER, PUBLIC :: u_ice_id, v_ice_id, adv_ice_id
+   REAL(wp), PUBLIC :: lim_nbstep = 0.    ! child time position in sea-ice model
+#if defined key_lim2_vp
+   REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:)     :: u_ice_nst, v_ice_nst   
+#else
+   REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:,:)   :: u_ice_oe, u_ice_sn     !: boundaries arrays
+   REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:,:)   :: v_ice_oe, v_ice_sn     !:  "          " 
+#endif
+   REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:,:,:) :: adv_ice_oe, adv_ice_sn !:  "          "
+
+   !!----------------------------------------------------------------------
+   !! NEMO/NST 3.3.4 , NEMO Consortium (2012)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS 
+
+   INTEGER FUNCTION agrif_ice_alloc()
+      !!----------------------------------------------------------------------
+      !!                ***  FUNCTION agrif_ice_alloc  ***
+      !!----------------------------------------------------------------------
+#if defined key_lim2_vp
+      ALLOCATE( u_ice_nst(jpi,jpj), v_ice_nst(jpi,jpj) ,   &
+#else
+      ALLOCATE( u_ice_oe(4,jpj,2) , v_ice_oe(4,jpj,2) ,    &
+         &      u_ice_sn(jpi,4,2) , v_ice_sn(jpi,4,2) ,    &
+#endif
+         &      adv_ice_oe (4,jpj,7,2) , adv_ice_sn (jpi,4,7,2) ,   &
+         &      STAT = agrif_ice_alloc)
+
+#if ! defined key_lim2_vp
+      u_ice_oe(:,:,:) =  0.e0
+      v_ice_oe(:,:,:) =  0.e0
+      u_ice_sn(:,:,:) =  0.e0
+      v_ice_sn(:,:,:) =  0.e0
+#endif
+      adv_ice_oe (:,:,:,:) = 0.e0 
+      adv_ice_sn (:,:,:,:) = 0.e0 
+      !
+   END FUNCTION agrif_ice_alloc
+
+#endif
+   !!======================================================================
+END MODULE agrif_ice
